import { CACHE_TYPES } from '../constants';

export var type = CACHE_TYPES.TTL;

export var buildStrategy = function buildStrategy(_ref) {
  var ttl = _ref.ttl;
  return { type: type, ttl: ttl };
};

export var shouldFetch = function shouldFetch(_ref2) {
  var state = _ref2.state,
      strategy = _ref2.strategy;

  if (state && strategy) {
    if (state.fetching) return false;
    if (state.fetched) {
      return state.timestamp + strategy.ttl <= Date.now();
    }
  }
  return true;
};
//# sourceMappingURL=ttl.js.map